function idx = func_define_idx

% define named indices into data matrices -- from MATPOWER
[idx.PQ, idx.PV, idx.REF, idx.NONE, idx.BUS_I, idx.BUS_TYPE, idx.PD, idx.QD, idx.GS, idx.BS, idx.BUS_AREA, idx.VM, idx.VA, ...
    idx.BASE_KV, idx.ZONE, idx.VMAX, idx.VMIN, idx.LAM_P, idx.LAM_Q, idx.MU_VMAX, idx.MU_VMIN] = idx_bus;
[idx.F_BUS, idx.T_BUS, idx.BR_R, idx.BR_X, idx.BR_B, idx.RATE_A, idx.RATE_B, idx.RATE_C, ...
    idx.TAP, idx.SHIFT, idx.BR_STATUS, idx.PF, idx.QF, idx.PT, idx.QT, idx.MU_SF, idx.MU_ST, ...
    idx.ANGMIN, idx.ANGMAX, idx.MU_ANGMIN, idx.MU_ANGMAX] = idx_brch;
[idx.GEN_BUS, idx.PG, idx.QG, idx.QMAX, idx.QMIN, idx.VG, idx.MBASE, idx.GEN_STATUS, idx.PMAX, idx.PMIN, ...
    idx.MU_PMAX, idx.MU_PMIN, idx.MU_QMAX, idx.MU_QMIN, idx.PC1, idx.PC2, idx.QC1MIN, idx.QC1MAX, ...
    idx.QC2MIN, idx.QC2MAX, idx.RAMP_AGC, idx.RAMP_10, idx.RAMP_30, idx.RAMP_Q, idx.APF] = idx_gen;
[idx.PW_LINEAR, idx.POLYNOMIAL, idx.MODEL, idx.STARTUP, idx.SHUTDOWN, idx.NCOST, idx.COST] = idx_cost;
[idx.CT_LABEL, idx.CT_PROB, idx.CT_TABLE, idx.CT_TBUS, idx.CT_TGEN, idx.CT_TBRCH, idx.CT_TAREABUS, ...
    idx.CT_TAREAGEN, idx.CT_TAREABRCH, idx.CT_ROW, idx.CT_COL, idx.CT_CHGTYPE, idx.CT_REP, ...
    idx.CT_REL, idx.CT_ADD, idx.CT_NEWVAL, idx.CT_TLOAD, idx.CT_TAREALOAD, idx.CT_LOAD_ALL_PQ, ...
    idx.CT_LOAD_FIX_PQ, idx.CT_LOAD_DIS_PQ, idx.CT_LOAD_ALL_P, idx.CT_LOAD_FIX_P, ...
    idx.CT_LOAD_DIS_P, idx.CT_TGENCOST, idx.CT_TAREAGENCOST, idx.CT_MODCOST_F, ...
    idx.CT_MODCOST_X] = idx_ct;